package eu.pequignat.function;

import eu.pequignat.MyFunction;
import eu.pequignat.runnable.MyRunnable;
import eu.pequignat.runnable.MyCallable;

import java.util.Iterator;
import java.util.List;
import java.util.Queue;
import java.util.concurrent.*;

import static eu.pequignat.constant.Constant.NB_THREAD_IN_PARALLEL;

public class MultiTreadingByForkJoinPool implements MyFunction {

    private final int parallelism;
    public MultiTreadingByForkJoinPool(int parallelism){
        this.parallelism=parallelism;
    }

    @Override
    public void run() {
        Queue<MyCallable> allFunctions = new ConcurrentLinkedQueue<>();
        message("Prepare the List of all Thread to start in parallel");
        for (int i = 0; i< NB_THREAD_IN_PARALLEL; i++){
            allFunctions.add(new MyCallable());
        }
        ForkJoinPool forkJoinPool = new ForkJoinPool(parallelism);
        message("run Callable in parallel: ".concat(String.valueOf(forkJoinPool.getParallelism())));
        try {
            List<Future<String>> futures =  forkJoinPool.invokeAll(allFunctions);
            message("All are terminated");
            for (Future<String> f : futures){
                try {
                    message(this.toString().concat(": ").concat(f.get()));
                } catch (ExecutionException e) {
                    LOG.error(e.getLocalizedMessage(),e);
                }
            }

        } catch (InterruptedException e) {
            LOG.error(e.getLocalizedMessage(),e);
        }

    }
}
