package eu.pequignat.runnable;

import eu.pequignat.MyFunction;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.concurrent.Callable;

import static eu.pequignat.constant.Constant.NB_LOOP;
import static eu.pequignat.constant.Constant.SLEEP_MS;

public class MyCallable implements Callable<String> {

    protected static Logger LOG = LoggerFactory.getLogger(MyFunction.class);

    public String getName(){
        return this.getClass().getName();
    }

    private void message(String message){
        LOG.debug(String.format("%s> %s", getName() ,message));
    }

    @Override
    public String call()  {
        final String refMemory= this.toString();
        message(refMemory.concat(".run()"));
        message(refMemory.concat("> loop ").concat(String.valueOf(NB_LOOP)));
        for (int i = 0; i< NB_LOOP; i++){
            message(String.format("%s> loop:%d", refMemory, i));
            try {
                Thread.sleep(SLEEP_MS);
            } catch (InterruptedException e) {
                LOG.error(e.getLocalizedMessage(),e);
            }
        }
        return "OK";
    }
}
